import React from 'react';
import { DefaultTheme } from 'styled-components';
import { HiroColors } from "../../../types";
export interface SelectItemProps {
    text?: string | number;
    value?: string | number;
    key?: string | number;
}
export interface SelectProps extends Omit<React.HTMLProps<HTMLDivElement>, 'onChange' | 'children'> {
    fluid?: boolean;
    basic?: boolean;
    className?: string;
    style?: React.CSSProperties;
    theme?: DefaultTheme;
    value?: string;
    text?: string;
    color?: HiroColors;
    compact?: boolean;
    dropup?: boolean;
    onChange?: (event: React.MouseEvent<HTMLDivElement, MouseEvent>, data: SelectItemProps) => void;
    onClear?: () => void;
    options?: SelectItemProps[];
}
export declare const Select: import("styled-components").StyledComponent<({ options, placeholder, value, onChange, onClear, fluid, basic, className, text, color, dropup, }: SelectProps) => JSX.Element, DefaultTheme, SelectProps, never>;
