var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import React, { useMemo, useCallback, useState, useEffect, useRef, } from 'react';
import styled, { css } from 'styled-components';
import cx from 'clsx';
import defaultCreatedTheme from "../../../theme";
import { Icon } from "../../elements";
var getDirection = function (_a) {
    var dropup = _a.dropup;
    return dropup ? 'top' : 'bottom';
};
var SelectDropdown = styled.div.withConfig({ displayName: "SelectDropdown", componentId: "sc-1xm0sme" })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: absolute;\n  z-index: 100;\n  width: 100%;\n  background-color: white;\n\n  max-height: 16rem;\n  overflow: auto;\n\n  border-left: 1px solid ", ";\n  border-right: 1px solid ", ";\n  border-", ": 1px solid ", ";\n\n  border-", "-left-radius: ", ";\n  border-", "-right-radius: ", ";\n\n  & > div.option {\n    width: 100%;\n    line-height: 1.5em;\n    padding: 0.5em 1em;\n    box-sizing: border-box;\n    cursor: pointer;\n\n    &.selected{\n    color:", ";\n    }\n\n    &:active:hover {\n      background-color: ", ";\n    }\n\n    &:hover,\n    &:focus {\n      background-color: ", ";\n    }\n  }\n\n  & > div.option:", " {\n    border-", "-left-radius: ", ";\n    border-", "-right-radius: ", ";\n  }\n"], ["\n  position: absolute;\n  z-index: 100;\n  width: 100%;\n  background-color: white;\n\n  max-height: 16rem;\n  overflow: auto;\n\n  border-left: 1px solid ",
    ";\n  border-right: 1px solid ",
    ";\n  border-", ": 1px solid ",
    ";\n\n  border-", "-left-radius: ",
    ";\n  border-", "-right-radius: ",
    ";\n\n  & > div.option {\n    width: 100%;\n    line-height: 1.5em;\n    padding: 0.5em 1em;\n    box-sizing: border-box;\n    cursor: pointer;\n\n    &.selected{\n    color:",
    ";\n    }\n\n    &:active:hover {\n      background-color: ", ";\n    }\n\n    &:hover,\n    &:focus {\n      background-color: ", ";\n    }\n  }\n\n  & > div.option:", " {\n    border-", "-left-radius: ",
    ";\n    border-", "-right-radius: ",
    ";\n  }\n"])), function (_a) {
    var theme = _a.theme, color = _a.color;
    return color ? theme.colors[color].default : theme.greyscale.dark;
}, function (_a) {
    var theme = _a.theme, color = _a.color;
    return color ? theme.colors[color].default : theme.greyscale.dark;
}, getDirection, function (_a) {
    var theme = _a.theme, color = _a.color;
    return color ? theme.colors[color].default : theme.greyscale.dark;
}, getDirection, function (_a) {
    var theme = _a.theme;
    return theme.sizes.borderRadiusInput;
}, getDirection, function (_a) {
    var theme = _a.theme;
    return theme.sizes.borderRadiusInput;
}, function (_a) {
    var theme = _a.theme, color = _a.color;
    return theme.colors[color ? color : 'primary'].default;
}, function (_a) {
    var theme = _a.theme;
    return theme.greyscale.dark;
}, function (_a) {
    var theme = _a.theme;
    return theme.greyscale.light;
}, function (_a) {
    var dropup = _a.dropup;
    return (dropup ? 'first-child' : 'last-child');
}, getDirection, function (_a) {
    var theme = _a.theme;
    return theme.sizes.borderRadiusInput;
}, getDirection, function (_a) {
    var theme = _a.theme;
    return theme.sizes.borderRadiusInput;
});
SelectDropdown.defaultProps = {
    theme: defaultCreatedTheme,
};
var SelectWrapper = styled.div.withConfig({ displayName: "SelectWrapper", componentId: "sc-10b44w1" })(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  position: relative;\n  display: inline-block;\n\n  ", "\n\n  ", "\n"], ["\n  position: relative;\n  display: inline-block;\n\n  ", "\n\n  ",
    "\n"])), function (_a) {
    var fluid = _a.fluid;
    return (fluid ? 'width:100%' : '');
}, function (_a) {
    var basic = _a.basic, dropup = _a.dropup;
    if (!basic) {
        return;
    }
    return css(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      & ", " {\n        ", ": 2em;\n        border-top-left-radius: ", ";\n        border-top-right-radius: ", ";\n\n        & > div.option:last-child {\n          border-top-left-radius: ", ";\n          border-top-right-radius: ", ";\n        }\n      }\n    "], ["\n      & ", " {\n        ", ": 2em;\n        border-top-left-radius: ", ";\n        border-top-right-radius: ",
        ";\n\n        & > div.option:last-child {\n          border-top-left-radius: ",
        ";\n          border-top-right-radius: ",
        ";\n        }\n      }\n    "])), SelectDropdown, dropup ? 'bottom' : 'top', function (_a) {
        var theme = _a.theme;
        return theme.sizes.borderRadiusInput;
    }, function (_a) {
        var theme = _a.theme;
        return theme.sizes.borderRadiusInput;
    }, function (_a) {
        var theme = _a.theme;
        return theme.sizes.borderRadiusInput;
    }, function (_a) {
        var theme = _a.theme;
        return theme.sizes.borderRadiusInput;
    });
});
SelectWrapper.defaultProps = {
    theme: defaultCreatedTheme,
};
export var Select = styled(function (_a) {
    var options = _a.options, placeholder = _a.placeholder, value = _a.value, onChange = _a.onChange, onClear = _a.onClear, fluid = _a.fluid, basic = _a.basic, className = _a.className, text = _a.text, color = _a.color, dropup = _a.dropup;
    var ref = useRef(null);
    var dropdown = useRef(null);
    var _b = useState(false), active = _b[0], setActive = _b[1];
    var selection = useMemo(function () {
        if (text) {
            return React.createElement("span", { className: "text" }, text);
        }
        if (value && options) {
            var item = options.find(function (o) { return o.value === value; });
            return React.createElement("span", null, item === null || item === void 0 ? void 0 : item.text);
        }
        return React.createElement("span", { className: "placeholder" }, placeholder);
    }, [options, placeholder, text, value]);
    var handleClear = useCallback(function (e) {
        onClear === null || onClear === void 0 ? void 0 : onClear();
        e.stopPropagation();
    }, [onClear]);
    var handleClick = useCallback(function () {
        setActive(!active);
    }, [active]);
    var handleClickOut = useCallback(function (e) {
        var _a;
        if ((_a = ref.current) === null || _a === void 0 ? void 0 : _a.contains(e.target)) {
            return;
        }
        setActive(false);
    }, []);
    var stateClassName = cx(className, {
        active: active,
        basic: basic,
    });
    var contents = useMemo(function () { return options === null || options === void 0 ? void 0 : options.map(function (o) { return (React.createElement("div", { key: o.key, className: cx('option', {
            selected: o.key === value,
        }), onClick: function (e) {
            onChange === null || onChange === void 0 ? void 0 : onChange(e, o);
            setActive(false);
        } }, o.text)); }); }, [onChange, options, value]);
    var showClear = useMemo(function () { return value && onClear; }, [onClear, value]);
    // Close on click outside
    useEffect(function () {
        document.addEventListener('mousedown', handleClickOut, false);
        return function () {
            return document.removeEventListener('mousedown', handleClickOut, false);
        };
    }, [handleClickOut]);
    return (React.createElement(SelectWrapper, { ref: ref, fluid: fluid, basic: basic },
        React.createElement("div", { className: stateClassName, onClick: handleClick },
            selection,
            React.createElement(Icon, { name: showClear ? 'times' : 'caret-down', onClick: showClear ? handleClear : undefined, fitted: true })),
        active && (React.createElement(SelectDropdown, { ref: dropdown, dropup: dropup, color: color }, contents))));
}).withConfig({ displayName: "Select", componentId: "sc-w9zw4a" })(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  cursor: pointer;\n  position: relative;\n  box-sizing: border-box;\n  height: 35px;\n\n  & > .placeholder {\n    color: ", ";\n    opacity: 1;\n  }\n\n  & > .text {\n    color: ", ";\n  }\n\n  & > i {\n    cursor: pointer;\n    position: absolute;\n    right: 0.8rem;\n    height: 100%;\n    top: 0;\n    display: flex;\n    align-items: center;\n    width: 20px;\n    justify-content: center;\n  }\n\n  &.basic {\n    border: none;\n    padding: 0 2.5em;\n  }\n\n  &:not(.basic) {\n    margin: 0;\n    outline: 0;\n    text-align: left;\n    line-height: 1.5em;\n    padding: 0.5em 4em 0.5em 1em;\n    min-width: ", ";\n\n    border-radius: ", ";\n    border: 1px solid\n      ", ";\n\n    &:focus,\n    &:focus:hover,\n    &:hover {\n      border-color: ", ";\n    }\n\n    &:hover {\n      box-shadow: 1px 1px 12px 0 ", ";\n    }\n\n    &:disabled {\n      background-color: transparent;\n\n      &:hover {\n        box-shadow: none;\n        border-color: ", ";\n      }\n    }\n\n    &::after {\n      content: '';\n      position: absolute;\n      top: 0;\n      bottom: 0;\n      right: 3em;\n      border-left: 1px solid\n        ", ";\n    }\n\n    & i {\n      color: ", ";\n    }\n\n    &.active {\n      border-", "-left-radius: 0;\n      border-", "-right-radius: 0;\n      border-color: ", ";\n    }\n  }\n"], ["\n  cursor: pointer;\n  position: relative;\n  box-sizing: border-box;\n  height: 35px;\n\n  & > .placeholder {\n    color: ", ";\n    opacity: 1;\n  }\n\n  & > .text {\n    color: ",
    ";\n  }\n\n  & > i {\n    cursor: pointer;\n    position: absolute;\n    right: 0.8rem;\n    height: 100%;\n    top: 0;\n    display: flex;\n    align-items: center;\n    width: 20px;\n    justify-content: center;\n  }\n\n  &.basic {\n    border: none;\n    padding: 0 2.5em;\n  }\n\n  &:not(.basic) {\n    margin: 0;\n    outline: 0;\n    text-align: left;\n    line-height: 1.5em;\n    padding: 0.5em 4em 0.5em 1em;\n    min-width: ", ";\n\n    border-radius: ", ";\n    border: 1px solid\n      ",
    ";\n\n    &:focus,\n    &:focus:hover,\n    &:hover {\n      border-color: ",
    ";\n    }\n\n    &:hover {\n      box-shadow: 1px 1px 12px 0 ", ";\n    }\n\n    &:disabled {\n      background-color: transparent;\n\n      &:hover {\n        box-shadow: none;\n        border-color: ",
    ";\n      }\n    }\n\n    &::after {\n      content: '';\n      position: absolute;\n      top: 0;\n      bottom: 0;\n      right: 3em;\n      border-left: 1px solid\n        ",
    ";\n    }\n\n    & i {\n      color: ",
    ";\n    }\n\n    &.active {\n      border-", "-left-radius: 0;\n      border-", "-right-radius: 0;\n      border-color: ",
    ";\n    }\n  }\n"])), function (_a) {
    var theme = _a.theme;
    return theme.greyscale.dark;
}, function (_a) {
    var theme = _a.theme, color = _a.color;
    return theme.colors[color ? color : 'primaryText'].default;
}, function (_a) {
    var compact = _a.compact;
    return (compact ? undefined : '256px');
}, function (_a) {
    var theme = _a.theme;
    return theme.sizes.borderRadiusInput;
}, function (_a) {
    var theme = _a.theme, color = _a.color;
    return color ? theme.colors[color].default : theme.greyscale.medium;
}, function (_a) {
    var theme = _a.theme, color = _a.color;
    return color ? theme.colors[color].hover : theme.greyscale.dark;
}, function (_a) {
    var theme = _a.theme;
    return theme.greyscale.dark;
}, function (_a) {
    var theme = _a.theme, color = _a.color;
    return color ? theme.colors[color].default : theme.greyscale.medium;
}, function (_a) {
    var theme = _a.theme, color = _a.color;
    return color ? theme.colors[color].default : theme.greyscale.medium;
}, function (_a) {
    var theme = _a.theme, color = _a.color;
    return color ? theme.colors[color].default : theme.greyscale.darker;
}, getDirection, getDirection, function (_a) {
    var theme = _a.theme, color = _a.color;
    return color ? theme.colors[color].default : theme.greyscale.medium;
});
Select.defaultProps = {
    theme: defaultCreatedTheme,
};
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
